'''
    Description:  Sorts myList in ascending order using a bubble sort.
    The bubble sort stops early if no items are exchanged when scanning
    the unsorted part of the list.
    File:  bubbleSortB.py
'''



def bubbleSort(myList):
    """Rearranges the items in myList so they are in ascending order"""
    for lastUnsortedIndex in xrange(len(myList)-1,0,-1):
        alreadySorted = True
        # scan the unsorted part at the beginning of myList
        for testIndex in xrange(lastUnsortedIndex):
            # if we find two adjacent items out of order, switch them
            if myList[testIndex] > myList[testIndex+1]:
                temp = myList[testIndex]
                myList[testIndex] = myList[testIndex+1]
                myList[testIndex+1] = temp
                alreadySorted = False
        if alreadySorted:
            return

import random

def shuffle(myList):
    for fromIndex in xrange(len(myList)):
        toIndex = random.randint(0,len(myList)-1)
        temp = myList[fromIndex]
        myList[fromIndex] = myList[toIndex]
        myList[toIndex] = temp
    

import time
            
aList = range(10000,0,-1)
print "unsorted list: ",
print aList[0],aList[1],aList[2], '...',aList[-3], aList[-2],aList[-1]
start = time.clock()
bubbleSort(aList)
end = time.clock()
print "sorted list:",
print aList[0],aList[1],aList[2], '...',aList[-3], aList[-2],aList[-1]
print "Time to sort",end - start,"seconds"

print "\nunsorted list: ",
print aList[0],aList[1],aList[2], '...',aList[-3], aList[-2],aList[-1]
start = time.clock()
bubbleSort(aList)
end = time.clock()
print "sorted list:",
print aList[0],aList[1],aList[2], '...',aList[-3], aList[-2],aList[-1]
print "Time to sort",end - start,"seconds"

aList = range(5000,0,-1) + range(10000,5000,-1)

print "\nunsorted list: ",
print aList[0],aList[1],aList[2], '...',aList[-3], aList[-2],aList[-1]
start = time.clock()
bubbleSort(aList)
end = time.clock()
print "sorted list:",
print aList[0],aList[1],aList[2], '...',aList[-3], aList[-2],aList[-1]
print "Time to sort",end - start,"seconds"

aList = range(10000,0,-1)
shuffle(aList)
print "\nunsorted (random) list: ",
print aList[0],aList[1],aList[2], '...',aList[-3], aList[-2],aList[-1]
start = time.clock()
bubbleSort(aList)
end = time.clock()
print "sorted list:",
print aList[0],aList[1],aList[2], '...',aList[-3], aList[-2],aList[-1]
print "Time to sort",end - start,"seconds"

aList = range(10000,0,-1)
shuffle(aList)
print "\nunsorted (random) list: ",
print aList[0],aList[1],aList[2], '...',aList[-3], aList[-2],aList[-1]
start = time.clock()
bubbleSort(aList)
end = time.clock()
print "sorted list:",
print aList[0],aList[1],aList[2], '...',aList[-3], aList[-2],aList[-1]
print "Time to sort",end - start,"seconds"

raw_input("Hit <Enter>-key to end")
