'''
    Description:  Sorts myList in ascending order using an selection sort.
    File:  selectionSort.py
'''

def selectionSort(aList):
    for firstUnsortedIndex in xrange(len(aList)-1):
        # look for minimum item in unsorted part of list
        # Assume minimum is the first item in the unsorted part
        minIndex = firstUnsortedIndex

        # scan down the unsorted part of the list to correct the assumption
        for testIndex in xrange(firstUnsortedIndex+1, len(aList)):
            if aList[testIndex] < aList[minIndex]:
                minIndex = testIndex

        # exchange the items at minIndex and firstUnsortedIndex
        temp = aList[firstUnsortedIndex]
        aList[firstUnsortedIndex] = aList[minIndex]
        aList[minIndex] = temp
        
import random

def shuffle(myList):
    for fromIndex in xrange(len(myList)):
        toIndex = random.randint(0,len(myList)-1)
        temp = myList[fromIndex]
        myList[fromIndex] = myList[toIndex]
        myList[toIndex] = temp
    

import time
            
aList = range(10000,0,-1)
print "\nunsorted list: ",
print aList[0],aList[1],aList[2], '...',aList[-3], aList[-2],aList[-1]
start = time.clock()
selectionSort(aList)
end = time.clock()
print "sorted list:",
print aList[0],aList[1],aList[2], '...',aList[-3], aList[-2],aList[-1]
print "Time to sort",end - start,"seconds"

print "\nunsorted list: ",
print aList[0],aList[1],aList[2], '...',aList[-3], aList[-2],aList[-1]
start = time.clock()
selectionSort(aList)
end = time.clock()
print "sorted list:",
print aList[0],aList[1],aList[2], '...',aList[-3], aList[-2],aList[-1]
print "Time to sort",end - start,"seconds"

aList = range(5000,0,-1) + range(10000,5000,-1)

print "\nunsorted list: ",
print aList[0],aList[1],aList[2], '...',aList[-3], aList[-2],aList[-1]
start = time.clock()
selectionSort(aList)
end = time.clock()
print "sorted list:",
print aList[0],aList[1],aList[2], '...',aList[-3], aList[-2],aList[-1]
print "Time to sort",end - start,"seconds"

aList = range(10000,0,-1)
shuffle(aList)
print "\nunsorted (random) list: ",
print aList[0],aList[1],aList[2], '...',aList[-3], aList[-2],aList[-1]
start = time.clock()
selectionSort(aList)
end = time.clock()
print "sorted list:",
print aList[0],aList[1],aList[2], '...',aList[-3], aList[-2],aList[-1]
print "Time to sort",end - start,"seconds"

aList = range(10000,0,-1)
shuffle(aList)
print "\nunsorted (random) list: ",
print aList[0],aList[1],aList[2], '...',aList[-3], aList[-2],aList[-1]
start = time.clock()
selectionSort(aList)
end = time.clock()
print "sorted list:",
print aList[0],aList[1],aList[2], '...',aList[-3], aList[-2],aList[-1]
print "Time to sort",end - start,"seconds"

raw_input("Hit <Enter>-key to end")
